#
# 
# Apply connector dimension from end spacing
#
# Written by Steve Karman
#
#

# Load Glyph and TK
package require PWI_Glyph

# define working directory
set scriptDir [file dirname [info script]]
source [file join $scriptDir "Utility.glf"]

set edgeMaxGrowthRate   1.3; # connector proximity growth rate
set conMinDim             3; # Minimum connector dimension
set conMaxDim           512; # Maximum connector dimension

set conList [pw::Grid getAll -type pw::Connector]
puts "Connector list has [llength $conList] entries."

# Adjust connector dimension based on end spacing

connectorDimensionFromEndSpacing $edgeMaxGrowthRate $conMinDim $conMaxDim $conList

pw::Display update

puts "Finished!"


