#
# 
# Apply Connector Proximity Dimensioning
#
# Written by Steve Karman
#
#

# Load Glyph and TK
package require PWI_Glyph

# define working directory
set scriptDir [file dirname [info script]]
source [file join $scriptDir "Utility.glf"]

set proxGrowthRate      1.3; # connector proximity growth rate
set conMinDim             3; # Minimum connector dimension
set conMaxDim           512; # Maximum connector dimension

set conList [pw::Grid getAll -type pw::Connector]
puts "Connector list has [llength $conList] entries."

# Adjust connector dimension in close proximity to other connectors

connectorProximitySpacing $proxGrowthRate $conMinDim $conMaxDim $conList

pw::Display update

puts "Finished!"


