#ifdef __cplusplus
extern "C" {
#endif

// Extract the FEPOINT Tecoplot data from a FUN3D Aero-Loads file (connectivity is ignored) - dataMatrix = [numVariable][numDataPoint]
int fun3d_readAeroLoad(char *filename, int *numVariable, char **variableName[], int *numDataPoint, double ***dataMatrix);


// Write FEPOINT Tecplot data for FUN3D (connectivity is optional) - dataMatrix = [numVariable][numDataPoint], connectMatrix (optional) = [4*numConnect]
//  the formating of the data may be specified through dataFormat = [numVariable] (use capsTypes Integer and Double)- If NULL default to double
int fun3d_writeTecplotFEPOINT(char *filename,
                              char *message,
                              char *zoneTitle,
                              int numVariable,
                              char *variableName[],
                              int numDataPoint,
                              double **dataMatrix,
                              int *dataFormat,
                              int numConnect,
                              int *connectMatrix,
                              double *solutionTime);

// Create a 3D mesh for FUN3D from a 2D mesh
int fun3d_2DMesh(meshStruct *surfaceMesh,
                 meshStruct *volumeMesh,
                 int *extrusionBCIndex);

// Write FUN3D data transfer files
int fun3D_dataTransfer(void *aimInfo,
                       char *analysisPath,
                       char *projectName,
                       meshStruct volumeMesh,
                       modalAeroelasticStruct *eigenVector);

// Write FUN3D fun3d.nml file
int fun3d_writeNML(void *aimInfo,
                   char *analysisPath,
                   capsValue *aimInputs,
                   cfdBCsStruct bcProps);

// Write FUN3D movingbody.input file
int fun3d_writeMovingBody(char *analysisPath,
                          cfdBCsStruct bcProps,
                          modalAeroelasticStruct *modalAeroelastic);

// Write FUN3D parametrization/sensitivity file
int fun3d_writeParameterization(void *aimInfo,
                                char *analysisPath,
                                meshStruct *volumeMesh,
                                int numGeomIn,
                                capsValue *geomInVal);

// Write FUN3D rubber.data file
int fun3d_writeRubber(void *aimInfo,
                      capsValue *aimInputs,
                      char *analysisPath,
                      meshStruct *volumeMesh,
                      int numGeomIn,
                      capsValue *geomInVal);

// Make FUN3D directory structure/tree:q
int fun3d_makeDirectory(char *analysisPath);

#ifdef __cplusplus
}
#endif
