from __future__ import print_function

# Import pyCAPS class file
from pyCAPS import capsProblem

# Import os module   
try: 
    import os
except:
    print ("Unable to import os module")
    raise SystemError

# Initialize capsProblem object
myProblem = capsProblem()

# Create working directory variable 
workDir = "egadsTessAnalysisTest"

# Load CSM file 
myProblem.loadCAPS("./csmData/cfd2D.csm")

# Set intention - could also be set during .loadAIM
myProblem.capsIntent = "ALL"

# Load egadsTess aim 
myAIM = myProblem.loadAIM(aim = "egadsTessAIM", analysisDir = workDir)

# Set new EGADS body tessellation parameters
myAIM.setAnalysisVal("Tess_Params", [.01, 0.001, 20.0])

# Set project name and output mesh type
myAIM.setAnalysisVal("Proj_Name", "egadsTessMesh")

myAIM.setAnalysisVal("Mesh_Format", "Airfoil")

# Run AIM pre-analysis
myAIM.aimPreAnalysis()

# NO analysis is needed - egadsTess was already ran during preAnalysis

# Run AIM post-analysis
myAIM.aimPostAnalysis()


# Close CAPS 
myProblem.closeCAPS()