
#cdef extern from "/home/dursch/Desktop/CAPS/EngSketchPad/src/wvServer/libwebsockets.h":
#    ctypedef struct libwebsocket:
#        pass
     
#cdef extern from "webViewer.c":
#    #void browserMessage(libwebsocket *wsi, char *text, int len)
#    void browserMessage(void *wsi, char *text, int len)

ctypedef wvContext * wvObj
    
cdef extern from "wsss.h":

    #/* Graphic Primitive Types */
    cdef int WV_POINT "WV_POINT"
    cdef int WV_LINE "WV_LINE"
    cdef int WV_TRIANGLE "WV_TRIANGLE"

    #/* Plotting Attribute Bits */
    cdef int WV_ON "WV_ON"
    cdef int WV_TRANSPARENT "WV_TRANSPARENT"
    cdef int WV_SHADING "WV_SHADING"
    cdef int WV_ORIENTATION "WV_ORIENTATION"
    cdef int WV_POINTS "WV_POINTS"
    cdef int WV_LINES "WV_LINES"
    
    #/* VBO & single data Bits */
    cdef int WV_VERTICES "WV_VERTICES"
    cdef int WV_INDICES "WV_INDICES"
    cdef int WV_COLORS "WV_COLORS"
    cdef int WV_NORMALS "WV_NORMALS"
    
    cdef int WV_PINDICES "WV_PINDICES"
    cdef int WV_LINDICES "WV_LINDICES"
    cdef int WV_PCOLOR "WV_PCOLOR"
    cdef int WV_LCOLOR "WV_LCOLOR"
    cdef int WV_BCOLOR "WV_BCOLOR"
    
    cdef int WV_DELETE "WV_DELETE"
    cdef int WV_DONE "WV_DONE"
    
    #/* Data Types */
    cdef int WV_UINT8  "WV_UINT8"
    cdef int WV_UINT16 "WV_UINT16"
    cdef int WV_INT32  "WV_INT32"
    cdef int WV_REAL32 "WV_REAL32"
    cdef int WV_REAL64 "WV_REAL64"

    ctypedef struct wvData:
        int    dataType         #     /* VBO type */
        int    dataLen          #    /* length of data */
        void  *dataPtr          #     /* pointer to data */
        float  data[3]          #    /* size = 1 data (not in ptr) */
    
    ctypedef struct wvStripe:
        pass
    
    ctypedef struct wvGPrim:
        pass
    
    ctypedef struct wvContext:
        int keepItems      #/* 0 - Items are transient, 1 - user control */
    
cdef extern from "wsserver.h":
    
    void wv_freeItem(wvData *item) # Added 
    
    int  wv_startServer( int port, char *interface, 
                                   char *cert_path, 
                                   char *key_path, int opts,
                                   wvContext *WVcontext )
                                  
    int  wv_statusServer( int index )
  
    int  wv_nClientServer( int index )

    wvContext *wv_createContext( int bias,   float fov,  float zNear, 
                                 float zFar, float *eye, float *center, 
                                 float *up )
    
    void wv_printGPrim( wvContext *cntxt, int index )

    int  wv_indexGPrim( wvContext *cntxt, char *name )

    int  wv_addGPrim( wvContext *cntxt, char *name, int gtype, 
                      int attrs, int nItems, wvData *items )
    
    void wv_removeGPrim( wvContext *cntxt, int index )
                               
    void wv_removeAll( wvContext *cntxt )
                               
    int  wv_modGPrim( wvContext *cntxt, int index, int nItems, wvData *items )
    
    int  wv_handShake( wvContext *cntxt )
                               
    int  wv_addArrowHeads( wvContext *cntxt, int index, float size, 
                           int nHeads, int *heads )
  
    int  wv_setKey( wvContext *context, int nCol, float *colors,
                    float beg, float end, char *title )

    int  wv_setData( int type, int len, void *data, int VBOtype, 
                     wvData *dstruct )

    # #ifndef STANDALONE
    void wv_sendText( void *wsi, char *text )
    # #endif

    void wv_broadcastText( char *text )
                              
    void wv_adjustVerts( wvData *dstruct, float *focus )

    void wv_cleanupServers() #( void )
