try:
    from setuptools import setup
    from setuptools import Extension
except ImportError:
    from distutils.core import setup
    from distutils.extension import Extension

capsModule =  Extension("pyCAPS", 
                        sources=["pyCAPS.c"],
                        libraries = ["legacy_stdio_definitions", "caps", "utils", "aimUtil", "ocsm", "egads", "udunits2", "Advapi32", "Ws2_32"],
                        extra_compile_args=['-Ox', '-MD', '-D_CRT_SECURE_NO_DEPRECATE'])

setup(name='pyCAPS',
      version='2.0',
      description='Python Extension Module to CAPS',
      author='Dr. Ryan Durscher',
      classifiers=[
                   # How mature is this project? Common values are
                   #   3 - Alpha
                   #   4 - Beta
                   #   5 - Production/Stable
                   'Development Status :: 4 - Beta',
                   # Compiled with Cython 0.24.1 - Supposed support for:
                   'Programming Language :: Python :: 2.6',
                   'Programming Language :: Python :: 2.7',
                   'Programming Language :: Python :: 3.2',
                   'Programming Language :: Python :: 3.3',
                   'Programming Language :: Python :: 3.4'
                   'Programming Language :: Python :: 3.5'],
      
      #install_requires=['json', 'os', 'time', 'math'],
      
      ext_modules = [capsModule]
)


#include_dirs = ["$(ESP_ROOT)/include", "$(ESP_ROOT)/include/$(ESP_ARCH)"],
#library_dirs = ["$(ESP_ROOT)/lib"]