/*
 *      CAPS: Computational Aircraft Prototype Syntheses
 *
 *             makes The Intent Dictionary for OpenCSM
 *
 *      Copyright 2014-2018, Massachusetts Institute of Technology
 *      Licensed under The GNU Lesser General Public License, version 2.1
 *      See http://www.opensource.org/licenses/lgpl-2.1.php
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define NEEDINTENT
#include "capsIntent.h"


int main(/*@unused@*/ int argc, /*@unused@*/ char *argv[])
{
  int  i, len;
  char *env, *file;
  FILE *fp;
  
  env = getenv("ESP_ROOT");
  if (env == NULL) {
    printf("\n Please set ESP_ROOT!\n\n");
    return 1;
  }
  len  = strlen(env);
  file = (char *) malloc((len+23)*sizeof(char));
  if (file == NULL) {
    printf("\n Malloc error on %d Characters!\n\n", len+23);
    return 1;
  }
#ifdef WIN32
  _snprintf(file, len+23, "%s\\include\\intent.dict", env);
#else
   snprintf(file, len+23, "%s/include/intent.dict", env);
#endif
  fp = fopen(file, "w");
  if (fp == NULL) {
    printf("\n Cannot Open %s!\n\n", file);
    free(file);
    return 1;
  }
  printf("\n Writing %s!\n\n", file);
  
  for (i = 1; i < NINTENT; i++)
    fprintf(fp, "%s %d\n", intents[i].name, intents[i].intent);
  
  fclose(fp);
  free(file);
  
  return 0;
}
